
%% OMS
Country_Name = "Germany";MAXData = 271;
%-Country_Name = "Denmark";MAXData = 171;
%-Country_Name = "Sweden"; MAXData = 198;
%-Country_Name = "Spain"; MAXData = 196;
%-Country_Name = "China";  MAXData = 225;
%-Country_Name = "China ";  MAXData = 104; % China sem ultimo aumento
%-Country_Name = "New Zealand"; MAXData = 170;
%-Country_Name = "Greece";MAXData = 171;
%-Country_Name = "Finland";  MAXData = 200;
%-Country_Name = "The United Kingdom"; MAXData = 195;

%*Country_Name = "France"; MAXData = 205;
%*Country_Name = "Brazil"; MAXData = 172;
%*Country_Name = "USA"; MAXData = 209;


%=================================================================================
fprintf('\nReading Data File....');
%=================================================================================
str_Data = "Country_" + Country_Name + ".csv";
DF = readtable(str_Data);
%%DF.Var1     % Pandemic Day
%%DF.Var2     % Pandemic Date
%%DF.Var6     % Total Deaths

DATA_X = DF.Var1;
DATA_Y = DF.Var6;
%=================================================================================
fprintf('\nStarting Richards Best Fit....');
%=================================================================================
PA_K = 0.0;
PA_A = 0.0;
PA_r = 0.0;
PA_s = 0.0;

RSq = 0.0;
index=0.0;
RichardsBestFit_X = [0;0];
RichardsBestFit_Y = [0;0];
plot(RichardsBestFit_X,RichardsBestFit_Y);
hold on 
for index=0:+1:50
    [xData, yData] = prepareCurveData( DATA_X, DATA_Y );
    str_fuction = "K * (( 1 + A * exp(-r*x))^(-1*" + index +"))";
    ft = fittype( str_fuction, 'independent', 'x', 'dependent', 'y' );
    %ft = fittype( 'K * (( 1 + A * exp(-r*x))^(-1*2))', 'independent', 'x', 'dependent', 'y' );
    opts = fitoptions( 'Method', 'NonlinearLeastSquares' );
    opts.Algorithm = 'Levenberg-Marquardt';
    opts.Display = 'Off';
    opts.Robust = 'LAR';
    opts.StartPoint = [0.157613081677548 0.970592781760616 0.957166948242946];
    
    % Fit model to data.
    [fitresult, gof] = fit( xData, yData, ft, opts );
    
    %fprintf('\n[%2d] [%f]; %f; %f; %f; %f \n',index,gof.rsquare,fitresult.K, fitresult.A, fitresult.r);

    if  gof.rsquare > RSq
        RSq = gof.rsquare;
        PA_K = fitresult.K;
        PA_A = fitresult.A;
        PA_r = fitresult.r;
        PA_s = index;
    end
    RichardsBestFit_X(index+1) = index+1;
    RichardsBestFit_Y(index+1) = gof.rsquare;
    plot(RichardsBestFit_X,RichardsBestFit_Y);
end
%=================================================================================
fprintf('\nBest Richards Parameters: K, A, r, s: %f;%f;%f;%f',PA_K,PA_A,PA_r,PA_s);
fprintf('\nCreating Richards data....');
%=================================================================================
Richards_RSq = RSq;
RichardsResult = [1;2];
for index=1:+1:MAXData
    RichardsResult(index) =  PA_K * (( 1 + PA_A * exp(-PA_r*index))^(-1*PA_s));
end
RichardsResult2 = [1;2];
for index=1:+1:MAXData
    ii = index + 1;
    if index >= MAXData
        ii = ii -1;
    end
    RichardsResult2(index) =  RichardsResult(ii) - RichardsResult(index);
end
%=================================================================================
fprintf('\nPerforming Gompertz Function Analysis....');
%=================================================================================

%=================================================================================
%Gompertz Analysis
%=================================================================================
[xData, yData] = prepareCurveData( DATA_X, DATA_Y);
ft = fittype( 'K *exp(-A*exp(-r*x))', 'independent', 'x', 'dependent', 'y' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares' );
opts.Algorithm = 'Levenberg-Marquardt';
opts.Display = 'Off';
opts.Robust = 'LAR';

opts.StartPoint = [0.5 DATA_Y(MAXData) 0.06];

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, opts );

Gompertz_RSq  = gof.rsquare;
PA_K = fitresult.K;
PA_A = fitresult.A;
PA_r = fitresult.r;
%=================================================================================
GompertzResults = [1;2];
for index=1:+1:MAXData
    GompertzResults(index) =  PA_K *exp(-PA_A*exp(-PA_r*index));
end
GompertzResults2 = [1;2];
for index=1:+1:MAXData
    ii = index + 1;
    if index >= MAXData
        ii = ii -1;
    end
    GompertzResults2(index) =  GompertzResults(ii) - GompertzResults(index);
end
%=================================================================================
fprintf('\nPerforming Logistic Function Analysis....');
%=================================================================================

%=================================================================================
%Logistic Analysis
%=================================================================================
[xData, yData] = prepareCurveData( DATA_X, DATA_Y );
ft = fittype( 'K / (1 + (A*exp(-r*x)))', 'independent', 'x', 'dependent', 'y' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares' );
opts.Algorithm = 'Levenberg-Marquardt';
opts.Display = 'Off';
opts.Robust = 'LAR';

opts.StartPoint = [0.5 DATA_Y(MAXData) 0.06];

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, opts );

Logistic_RSq  = gof.rsquare;
PA_K = fitresult.K;
PA_A = fitresult.A;
PA_r = fitresult.r;
%=================================================================================
LogisticResults = [1;2];
for index=1:+1:MAXData
    LogisticResults(index) =  PA_K / (1 + (PA_A*exp(-PA_r*index)));
end
LogisticResults2 = [1;2];
for index=1:+1:MAXData
    ii = index + 1;
    if index >= MAXData
        ii = ii -1;
    end
    LogisticResults2(index) =  LogisticResults(ii) - LogisticResults(index);
end
%=================================================================================
fprintf('\nPerforming Graphical data....');
%=================================================================================

%=================================================================================
%New Death Graph
%=================================================================================
MAT = ([RichardsResult2, GompertzResults2 , LogisticResults2]);
NewDeathsGraph(DF.Var1,DF.Var5,MAT,Country_Name,Richards_RSq,Gompertz_RSq,Logistic_RSq);
str_F_Title = "01_" + Country_Name + "_NewDeaths.png";
saveas(gcf,str_F_Title);
%=================================================================================
%Total Death Graph
%=================================================================================
MAT2 = ([RichardsResult, GompertzResults , LogisticResults]);
TotalDeathsGraph(DF.Var1,DF.Var6,MAT2,Country_Name,Richards_RSq,Gompertz_RSq,Logistic_RSq);
str_F_Title = "02_" + Country_Name + "_TotalDeaths.png";
saveas(gcf,str_F_Title);




