function NewDeathsGraph(xvector1, yvector1, YMatrix1,Pa_Title,Pa_Rsq_R,Pa_Rsq_G,Pa_Rsq_L)
%CREATEFIGURE(xvector1, yvector1, YMatrix1)
%  XVECTOR1:  bar xvector
%  YVECTOR1:  bar yvector
%  YMATRIX1:  matrix of y data

%  Auto-generated by MATLAB on 15-Aug-2020 18:08:08

% Create figure
figure1 = figure;

% Create axes
axes1 = axes('Parent',figure1);
hold(axes1,'on');

% Create bar
bar(xvector1,yvector1,'DisplayName','Deaths/day','FaceAlpha',0.5,...
    'EdgeColor','none');

% Create multiple lines using matrix input to plot
plot1 = plot(xvector1,YMatrix1,'MarkerSize',3,'Parent',axes1);
str1 = "Richards: R²(" + Pa_Rsq_R +")";
str2 = "Gompertz: R²(" + Pa_Rsq_G +")";
str3 = "Logistic: R²(" + Pa_Rsq_L +")";
set(plot1(1),'DisplayName',str1,'Marker','+');
%set(plot1(1),'DisplayName','Richards','Marker','+');
set(plot1(2),'DisplayName',str2,'Marker','o');
set(plot1(3),'DisplayName',str3,'Marker','x');

% Create ylabel
ylabel('Deaths','Interpreter','latex');

% Create xlabel
xlabel('Pandemic days','Interpreter','latex');

% Create title
title(Pa_Title,'Interpreter','latex');

box(axes1,'on');
grid(axes1,'on');
hold(axes1,'off');
% Set the remaining axes properties
set(axes1,'XMinorGrid','on','YMinorGrid','on');
% Create legend
legend(axes1,'show');


